<template>
  <div class='app'>


    <a-button @click='handleReload' :loading='loadingMore'
              style='position: absolute;z-index: 300;right: 140px;top: 45px' type='primary'>
      刷新
    </a-button>
    <a-button @click='handleOk' style='position: absolute;z-index: 300;right: 40px;top: 45px' type='primary'>
      提交周报
    </a-button>

    <weekly-list-compent :zpDisabled='false' :model='model' @submit='submit' :show-load-model='false'
                         :loadingMore='loadingMore' @reload='handleReload' :show-action='true' />
  </div>


</template>

<script>

import { querySingleThisWeek } from '@api/week'
import { deleteAction, getAction, postAction, putAction } from '@api/manage'
import WeeklyListCompent from '@views/week/modules/WeeklyListCompent'
import { ulid } from 'ulid'

export default {
  name: 'RightWriteWeekly',
  components: { WeeklyListCompent },
  data() {
    return {
      loadingMore: false,
      //填写的周报信息
      model: {
        // weekList: [],
        // weekExtList: [],
        // planList: [],
        // planExtList: [],
        weekList: [
          /* {
             year: '',
             week: '',
             startDateStr: '',
             endDateStr: '',
             typeList: [
               {
                 week: '',
                 type: 1,
                 wekList: []
               },
               {
                 week: '',
                 type: 2,
                 wekList: []
               }, {
                 week: '',
                 type: 3,
                 wekList: []
               }, {
                 week: '',
                 type: 4,
                 wekList: []
               }
             ]

           },
           {
             year: '',
             week: '',
             startDateStr: '',
             endDateStr: '',
             typeList: [
               {
                 week: '',
                 type: 1,
                 wekList: []
               },
               {
                 week: '',
                 type: 2,
                 wekList: []
               }, {
                 week: '',
                 type: 3,
                 wekList: []
               }, {
                 week: '',
                 type: 4,
                 wekList: []
               }
             ]

           }*/
        ]

      },

      url: {
        addBatch: '/wek/record/addBatch',
        add: '/wek/record/add',
        edit: '/wek/record/edit',
        evaluateEdit: '/wek/evaluate/edit'

      }
    }
  },
  created() {
    this.onLoadMore()
  },
  methods: {
    //查询本人这周和上周的周报信息
    onLoadMore() {
      this.loadingMore = true
      querySingleThisWeek({}).then((res) => {
        this.loading = false
        if (res.success) {
          if (res.result) {
            this.model.weekList = res.result

            //如果有数据。添加id
            if (this.model.weekList) {
              this.model.weekLis = this.model.weekList.map(item => {
                if (!item.id) {
                  item.id = ulid()
                }
                //a-select不显示placehold处理
                for (let prop in item.wekEvaluate) {
                  if (item.wekEvaluate.hasOwnProperty(prop)) {
                    if (item.wekEvaluate[prop] == null) {
                      item.wekEvaluate[prop] = undefined
                    }
                  }
                }
                return item
              })

            }
            console.info(this.model.weekList)
            this.$forceUpdate()
          }
        }
        this.loadingMore = false
        this.$nextTick(() => {
          window.dispatchEvent(new Event('resize'))
        })
      }).finally(() => {

      })
    },
    /**
     * 提交周报
     */
    handleOk() {
      let that = this

      this.$confirm({
        title: '提示',
        content: h => <div>确定提交本周周报吗？</div>,
        onOk() {

          console.info(that.model)

          //add
          if (!that.model.id) {
            postAction(that.url.addBatch, that.model)
              .then((res) => {
                if (res.success) {
                  that.$message.success(res.message)
                  //重新查询周报列表
                  that.onLoadMore()
                } else {
                  that.$message.warning(res.message)
                }
              })
              .finally(() => {

              })

            //edit
          } else {
            putAction(that.url.edit, that.model)
              .then((res) => {
                that.confirmLoading = false
                if (res.success) {
                  that.$message.success(res.message)
                } else {
                  that.$message.warning(res.message)
                }
              })
              .finally(() => {
                that.confirmLoading = false
              })
          }


        },
        onCancel() {

        },
        class: 'test'
      })
    },

    //自动提交
    submit(item, evaluate) {
      console.info(item)
      console.info(evaluate)
      //add
      if (item) {
        postAction(this.url.add, item)
          .then((res) => {
            if (res.success) {
              //重新查询周报列表
              //that.onLoadMore()
            } else {
              this.$message.warning(res.message)
            }
          })
          .finally(() => {

          })
      }

      if (evaluate) {
        postAction(this.url.evaluateEdit, evaluate)
          .then((res) => {
            if (res.success) {
              //重新查询周报列表
              //that.onLoadMore()
            } else {
              this.$message.warning(res.message)
            }
          })
          .finally(() => {

          })
      }


    },

    handleReload() {
      this.onLoadMore()
    }
  },
  computed: {}
}
</script>

<style lang='less' scoped>
.app {
  width: 100%;
  height: 100%;
  background: white;
  min-height: calc(100vh - 140px);


}


</style>